# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from scc_firewall_manager_sdk.models.connector_type import ConnectorType
from scc_firewall_manager_sdk.models.labels import Labels
from typing import Optional, Set
from typing_extensions import Self

class AsaCreateOrUpdateInput(BaseModel):
    """
    AsaCreateOrUpdateInput
    """ # noqa: E501
    connector_name: Optional[StrictStr] = Field(default=None, description="The name of the Secure Device Connector (SDC) that will be used to communicate with the device. This value is not required if the connector type selected is Cloud Connector (CDG).", alias="connectorName")
    connector_type: ConnectorType = Field(alias="connectorType")
    device_address: Optional[StrictStr] = Field(default=None, description="The address of the device to onboard, specified in the format `host:port`.", alias="deviceAddress")
    ignore_certificate: Optional[StrictBool] = Field(default=False, description="Set this attribute to true if you do not want Security Cloud Control to validate the certificate of this device before onboarding.", alias="ignoreCertificate")
    labels: Optional[Labels] = None
    name: Annotated[str, Field(min_length=1, strict=True)] = Field(description="A human-readable name for the device.")
    password: Annotated[str, Field(min_length=1, strict=True)] = Field(description="The password used to authenticate with the device.")
    username: Annotated[str, Field(min_length=1, strict=True)] = Field(description="The username used to authenticate with the device.")
    __properties: ClassVar[List[str]] = ["connectorName", "connectorType", "deviceAddress", "ignoreCertificate", "labels", "name", "password", "username"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AsaCreateOrUpdateInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of labels
        if self.labels:
            _dict['labels'] = self.labels.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AsaCreateOrUpdateInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "connectorName": obj.get("connectorName"),
            "connectorType": obj.get("connectorType"),
            "deviceAddress": obj.get("deviceAddress"),
            "ignoreCertificate": obj.get("ignoreCertificate") if obj.get("ignoreCertificate") is not None else False,
            "labels": Labels.from_dict(obj["labels"]) if obj.get("labels") is not None else None,
            "name": obj.get("name"),
            "password": obj.get("password"),
            "username": obj.get("username")
        })
        return _obj


