# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from scc_firewall_manager_sdk.models.shared_object_value import SharedObjectValue
from typing import Optional, Set
from typing_extensions import Self

class CreateRequest(BaseModel):
    """
    CreateRequest
    """ # noqa: E501
    description: Optional[StrictStr] = Field(default=None, description="The human-readable description of the object")
    labels: Optional[List[StrictStr]] = Field(default=None, description="The labels for the object")
    name: Annotated[str, Field(min_length=1, strict=True)] = Field(description="The name of the object")
    tags: Optional[Dict[str, List[StrictStr]]] = Field(default=None, description="The tags for the object")
    target_ids: Optional[List[StrictStr]] = Field(default=None, description="Set of IDs for targets that contain the object. A target can be, for example, a device, service, or a shared policy (Ruleset).", alias="targetIds")
    value: SharedObjectValue
    __properties: ClassVar[List[str]] = ["description", "labels", "name", "tags", "targetIds", "value"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of value
        if self.value:
            _dict['value'] = self.value.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "labels": obj.get("labels"),
            "name": obj.get("name"),
            "tags": obj.get("tags"),
            "targetIds": obj.get("targetIds"),
            "value": SharedObjectValue.from_dict(obj["value"]) if obj.get("value") is not None else None
        })
        return _obj


