# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from scc_firewall_manager_sdk.models.ftd_version import FtdVersion
from typing import Optional, Set
from typing_extensions import Self

class FtdCompatibilityVersion(BaseModel):
    """
    FtdCompatibilityVersion
    """ # noqa: E501
    compatible_ftd_versions: Optional[List[FtdVersion]] = Field(default=None, alias="compatibleFtdVersions")
    device_uids: Optional[List[StrictStr]] = Field(default=None, alias="deviceUids")
    hardware_model: Optional[StrictStr] = Field(default=None, alias="hardwareModel")
    __properties: ClassVar[List[str]] = ["compatibleFtdVersions", "deviceUids", "hardwareModel"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FtdCompatibilityVersion from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in compatible_ftd_versions (list)
        _items = []
        if self.compatible_ftd_versions:
            for _item in self.compatible_ftd_versions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['compatibleFtdVersions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FtdCompatibilityVersion from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "compatibleFtdVersions": [FtdVersion.from_dict(_item) for _item in obj["compatibleFtdVersions"]] if obj.get("compatibleFtdVersions") is not None else None,
            "deviceUids": obj.get("deviceUids"),
            "hardwareModel": obj.get("hardwareModel")
        })
        return _obj


