# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class FtdVersion(BaseModel):
    """
    FtdVersion
    """ # noqa: E501
    filename: Optional[StrictStr] = Field(default=None, description="The name of the file")
    is_suggested_version: Optional[StrictBool] = Field(default=None, description="A boolean value, indicating whether this version is a suggested version to upgrade to.", alias="isSuggestedVersion")
    software_version: Optional[StrictStr] = Field(default=None, description="The version to which this package will upgrade the FTD.", alias="softwareVersion")
    upgrade_package_uid: Optional[StrictStr] = Field(default=None, description="The unique identifier, represented as a UUID, of the version in Security Cloud Control", alias="upgradePackageUid")
    upgrade_type: Optional[StrictStr] = Field(default=None, description="The type of the upgrade", alias="upgradeType")
    __properties: ClassVar[List[str]] = ["filename", "isSuggestedVersion", "softwareVersion", "upgradePackageUid", "upgradeType"]

    @field_validator('upgrade_type')
    def upgrade_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['UPGRADE', 'PATCH', 'HOTFIX']):
            raise ValueError("must be one of enum values ('UPGRADE', 'PATCH', 'HOTFIX')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FtdVersion from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FtdVersion from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "filename": obj.get("filename"),
            "isSuggestedVersion": obj.get("isSuggestedVersion"),
            "softwareVersion": obj.get("softwareVersion"),
            "upgradePackageUid": obj.get("upgradePackageUid"),
            "upgradeType": obj.get("upgradeType")
        })
        return _obj


