# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from scc_firewall_manager_sdk.models.config_state import ConfigState
from scc_firewall_manager_sdk.models.conflict_detection_state import ConflictDetectionState
from scc_firewall_manager_sdk.models.connectivity_state import ConnectivityState
from scc_firewall_manager_sdk.models.entity_type import EntityType
from typing import Optional, Set
from typing_extensions import Self

class MspManagedCloudService(BaseModel):
    """
    MspManagedCloudService
    """ # noqa: E501
    address: Optional[StrictStr] = Field(default=None, description="The address of the cloud service (if applicable), in <code>host:port</code> format. Security Cloud Control connects to the cloud service at this address.")
    cloud_service_type: Optional[EntityType] = Field(default=None, alias="cloudServiceType")
    config_state: Optional[ConfigState] = Field(default=None, alias="configState")
    conflict_detection_state: Optional[ConflictDetectionState] = Field(default=None, alias="conflictDetectionState")
    connectivity_state: Optional[ConnectivityState] = Field(default=None, alias="connectivityState")
    managed_tenant_display_name: Optional[StrictStr] = Field(default=None, description="The display name of the managed tenant in CDO.", alias="managedTenantDisplayName")
    managed_tenant_name: Optional[StrictStr] = Field(default=None, description="The name of the managed tenant in CDO.", alias="managedTenantName")
    managed_tenant_region: Optional[StrictStr] = Field(default=None, description="The region of the managed tenant in CDO. This is the region where the cloud service is located.", alias="managedTenantRegion")
    managed_tenant_uid: Optional[StrictStr] = Field(default=None, description="The unique identifier, represented as a UUID, of the managed tenant in Security Cloud Control that this cloud service belongs to.", alias="managedTenantUid")
    name: StrictStr = Field(description="The name of the cloud service in CDO. Cloud service names are unique in Security Cloud Control.")
    tenant_uid: Optional[StrictStr] = Field(default=None, alias="tenantUid")
    uid: Optional[StrictStr] = Field(default=None, description="The unique identifier, represented as a UUID, of the cloud service in Security Cloud Control.")
    __properties: ClassVar[List[str]] = ["address", "cloudServiceType", "configState", "conflictDetectionState", "connectivityState", "managedTenantDisplayName", "managedTenantName", "managedTenantRegion", "managedTenantUid", "name", "tenantUid", "uid"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MspManagedCloudService from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MspManagedCloudService from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "address": obj.get("address"),
            "cloudServiceType": obj.get("cloudServiceType"),
            "configState": obj.get("configState"),
            "conflictDetectionState": obj.get("conflictDetectionState"),
            "connectivityState": obj.get("connectivityState"),
            "managedTenantDisplayName": obj.get("managedTenantDisplayName"),
            "managedTenantName": obj.get("managedTenantName"),
            "managedTenantRegion": obj.get("managedTenantRegion"),
            "managedTenantUid": obj.get("managedTenantUid"),
            "name": obj.get("name"),
            "tenantUid": obj.get("tenantUid"),
            "uid": obj.get("uid")
        })
        return _obj


