# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from scc_firewall_manager_sdk.models.connectivity_state import ConnectivityState
from scc_firewall_manager_sdk.models.entity_type import EntityType
from typing import Optional, Set
from typing_extensions import Self

class MspManagedDeviceManagerDistinctAttributeValues(BaseModel):
    """
    MspManagedDeviceManagerDistinctAttributeValues
    """ # noqa: E501
    connectivity_states: Optional[List[ConnectivityState]] = Field(default=None, description="The distinct connectivity states for the device managers managed by the MSP Portal.", alias="connectivityStates")
    device_manager_types: Optional[List[EntityType]] = Field(default=None, description="The distinct device manager types for the device managers managed by the MSP Portal.", alias="deviceManagerTypes")
    managed_tenant_display_names: Optional[List[StrictStr]] = Field(default=None, description="The display names of the tenants that have device managers onboarded and are managed by the MSP Portal.", alias="managedTenantDisplayNames")
    managed_tenant_names: Optional[List[StrictStr]] = Field(default=None, description="The names of the tenants that have device managers onboarded and are managed by the MSP Portal.", alias="managedTenantNames")
    software_versions: Optional[Dict[str, List[StrictStr]]] = Field(default=None, description="The software versions of the device managers managed by the MSP Portal.", alias="softwareVersions")
    __properties: ClassVar[List[str]] = ["connectivityStates", "deviceManagerTypes", "managedTenantDisplayNames", "managedTenantNames", "softwareVersions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MspManagedDeviceManagerDistinctAttributeValues from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MspManagedDeviceManagerDistinctAttributeValues from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "connectivityStates": obj.get("connectivityStates"),
            "deviceManagerTypes": obj.get("deviceManagerTypes"),
            "managedTenantDisplayNames": obj.get("managedTenantDisplayNames"),
            "managedTenantNames": obj.get("managedTenantNames"),
            "softwareVersions": obj.get("softwareVersions")
        })
        return _obj


