# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class S2sVpnTunnelHealthMetrics(BaseModel):
    """
    S2sVpnTunnelHealthMetrics
    """ # noqa: E501
    tunnel_id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the S2S VPN tunnel.", alias="tunnelId")
    tunnel_name: Optional[StrictStr] = Field(default=None, description="The name assigned to the S2S VPN tunnel.", alias="tunnelName")
    tunnel_state: Optional[StrictStr] = Field(default=None, description="The state of the S2S VPN tunnel. The possible values are TUNNEL_UP, TUNNEL_DOWN, and UNKNOWN.", alias="tunnelState")
    __properties: ClassVar[List[str]] = ["tunnelId", "tunnelName", "tunnelState"]

    @field_validator('tunnel_state')
    def tunnel_state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['TUNNEL_UP', 'TUNNEL_DOWN', 'UNKNOWN']):
            raise ValueError("must be one of enum values ('TUNNEL_UP', 'TUNNEL_DOWN', 'UNKNOWN')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of S2sVpnTunnelHealthMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of S2sVpnTunnelHealthMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tunnelId": obj.get("tunnelId"),
            "tunnelName": obj.get("tunnelName"),
            "tunnelState": obj.get("tunnelState")
        })
        return _obj


