# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SecureAccessMetadata(BaseModel):
    """
    SecureAccessMetadata
    """ # noqa: E501
    commit_status: Optional[StrictStr] = Field(default=None, description="The deployment status of the Secure Access configuration associated with the device.", alias="commitStatus")
    num_resources: Optional[StrictInt] = Field(default=None, description="The number of private Cisco Secure Access resources associated with the device.", alias="numResources")
    num_rules: Optional[StrictInt] = Field(default=None, description="The number of Cisco Secure Access rules associated with the device.", alias="numRules")
    __properties: ClassVar[List[str]] = ["commitStatus", "numResources", "numRules"]

    @field_validator('commit_status')
    def commit_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['CREATED', 'VALIDATION_FAILED', 'QUEUED', 'IN_PROGRESS', 'SKIPPED', 'PARTIALLY_SUCCESSFUL', 'SUCCESSFULLY_COMPLETED', 'FAILED', 'UNKNOWN']):
            raise ValueError("must be one of enum values ('CREATED', 'VALIDATION_FAILED', 'QUEUED', 'IN_PROGRESS', 'SKIPPED', 'PARTIALLY_SUCCESSFUL', 'SUCCESSFULLY_COMPLETED', 'FAILED', 'UNKNOWN')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SecureAccessMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SecureAccessMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "commitStatus": obj.get("commitStatus"),
            "numResources": obj.get("numResources"),
            "numRules": obj.get("numRules")
        })
        return _obj


