# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SourceNetworkContent(BaseModel):
    """
    The source network.
    """ # noqa: E501
    elements: Optional[List[StrictStr]] = Field(default=None, description="The list of elements.")
    name: StrictStr = Field(description="The name")
    type: Optional[StrictStr] = Field(default=None, description="The type of the policy object.")
    uid: Optional[StrictStr] = Field(default=None, description="The unique identifier.")
    __properties: ClassVar[List[str]] = ["elements", "name", "type", "uid"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NETWORK_OBJECT', 'IPV4_ADDRESS_POOL', 'IPV6_ADDRESS_POOL', 'NETWORK_GROUP', 'SERVICE_OBJECT', 'SERVICE_TCP_OBJECT', 'SERVICE_UDP_OBJECT', 'SERVICE_ICMPV4_OBJECT', 'SERVICE_ICMPV6_OBJECT', 'SERVICE_PROTOCOL_OBJECT', 'SERVICE_GROUP', 'SERVICE_FTD_GROUP', 'PROTOCOL_GROUP', 'ICMP_GROUP', 'URL_OBJECT', 'URL_GROUP', 'APPLICATION_FILTER_OBJECT', 'TIME_RANGE']):
            raise ValueError("must be one of enum values ('NETWORK_OBJECT', 'IPV4_ADDRESS_POOL', 'IPV6_ADDRESS_POOL', 'NETWORK_GROUP', 'SERVICE_OBJECT', 'SERVICE_TCP_OBJECT', 'SERVICE_UDP_OBJECT', 'SERVICE_ICMPV4_OBJECT', 'SERVICE_ICMPV6_OBJECT', 'SERVICE_PROTOCOL_OBJECT', 'SERVICE_GROUP', 'SERVICE_FTD_GROUP', 'PROTOCOL_GROUP', 'ICMP_GROUP', 'URL_OBJECT', 'URL_GROUP', 'APPLICATION_FILTER_OBJECT', 'TIME_RANGE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SourceNetworkContent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SourceNetworkContent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "elements": obj.get("elements"),
            "name": obj.get("name"),
            "type": obj.get("type"),
            "uid": obj.get("uid")
        })
        return _obj


