# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class UserCreateOrUpdateInput(BaseModel):
    """
    UserCreateOrUpdateInput
    """ # noqa: E501
    api_only_user: Optional[StrictBool] = Field(default=False, description="Whether the user is API-only, an API-only user cannot access Security Cloud Control in the UI.", alias="apiOnlyUser")
    first_name: Optional[StrictStr] = Field(default=None, description="The first name of the user in Security Cloud Control. Note: This field must not be specified for API-only users.", alias="firstName")
    last_name: Optional[StrictStr] = Field(default=None, description="The last name of the user in Security Cloud Control. Note: This field must not be specified for API-only users.", alias="lastName")
    name: Annotated[str, Field(min_length=1, strict=True)] = Field(description="The name of the user in Security Cloud Control. This has to be a valid email if creating a human user, and must not be an email if creating an API-only user.")
    role: Optional[StrictStr] = Field(default=None, description="The user role in Security Cloud Control.")
    __properties: ClassVar[List[str]] = ["apiOnlyUser", "firstName", "lastName", "name", "role"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserCreateOrUpdateInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserCreateOrUpdateInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "apiOnlyUser": obj.get("apiOnlyUser") if obj.get("apiOnlyUser") is not None else False,
            "firstName": obj.get("firstName"),
            "lastName": obj.get("lastName"),
            "name": obj.get("name"),
            "role": obj.get("role")
        })
        return _obj


